function result = rotQ(coords, rotator)
% result = rotQ(COORDS, ROTATOR) returns the vectors
% in COORDS rotated by the quaternion ROTATOR. COORDS
% must be a (n,3) matrix, and the ROTATOR must be a unit
% (4)-vector, representing a rotation quaternion.
% The result returned is a (n,3) matrix of vectors in 3-space.

n = size(coords, 1);

tempCoords = [zeros(n,1),coords];

conjRotator = conjQ(rotator);
for i = 1 : n,
   tempResult(i,:) = mulQ (mulQ (rotator, tempCoords(i, :)), conjRotator);
end

result = tempResult(:,2:4);